package com.izouma.awesomeadmin.web;

import java.util.*;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ContactRecord;
import com.izouma.awesomeadmin.service.ContactRecordService;

/**
*  controller类
*/
@Controller
@RequestMapping("/contactRecord")
public class ContactRecordController extends BaseController{

    @Autowired
    private ContactRecordService contactRecordService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ContactRecord record) {
        List<ContactRecord> pp = contactRecordService.getContactRecordList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getContactRecord", method = RequestMethod.GET)
    @ResponseBody
    public Result getContactRecord(@RequestParam(required = false, value = "id") String id) {
        ContactRecord data = contactRecordService.getContactRecordById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ContactRecord record) {
        ContactRecord data = contactRecordService.getContactRecord(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ContactRecord record) {
        Map<String, Object> result = new HashMap<>();

        List<ContactRecord> pp =contactRecordService.getContactRecordByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ContactRecord record) {
        boolean num = contactRecordService.createContactRecord(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateContactRecord(ContactRecord record) {
        boolean num = contactRecordService.updateContactRecord(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteContactRecord(@RequestParam(required = true, value = "id") String id) {

        boolean num = contactRecordService.deleteContactRecord(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }
}

